#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "stricmp.h"

main (int argc, char *argv[]) {
	int i,k = 0;
	char cntrl[256];
	char graph[256];
	char print[256];
	char punct[256];
	char *which = NULL;

	for (i=0; i < 256; i++) {
		cntrl[i] = (iscntrl(i) ? '+' : ' ');
		graph[i] = (isgraph(i) ? '+' : ' ');
		print[i] = (isprint(i) ? '+' : ' ');
		punct[i] = (ispunct(i) ? '+' : ' ');
		}

	if (argc > 1) {
		if (stricmp (argv[1],"cntrl") == 0) which = cntrl;
		if (stricmp (argv[1],"graph") == 0) which = graph;
		if (stricmp (argv[1],"print") == 0) which = print;
		if (stricmp (argv[1],"punct") == 0) which = punct;
		}

	if (which) {
		printf ("0x00: ");
		for (i=0; i < 256; i++) {
			char c = (isprint(i) ?  i  : '.');
			printf (" %c%c",c,which[i]);
			k++;
			if (k == 16) {
				k = 0;
				printf ("\n");
				printf ("0x%02X: ",i+1);
				}
			}
		printf ("\n");
		}
	else
		fprintf (stderr,"Usage: %s cntrl | graph | print | punct\n",argv[0]);
	}
